﻿
/**
 *	2次元ベジェ曲線上を移動
 */

package {
	
	import flash.display.Sprite;
	import flash.display.Shape;
	import flash.display.Graphics;
	import flash.geom.Point;
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	import ShapeData;
	import VectorPoint;
	
	public class Bezje2DTest5 extends Sprite{
		
		private var shape_data:ShapeData;
		
		private var line:Shape;
		private var obj:Shape;
		
		private var line_step:uint = 0;
		private var step:Number = 0;
		
		private var vk:Number = 0.0;	//とりあえず速度
		
		private var accel:Boolean = false;
		
		public function Bezje2DTest5(){
			
			line = new Shape();
			obj = new Shape();
			addChild( line );
			addChild( obj );
			
			
			//ShapeData
			var dat:XML = <shape>
				<edge id="0" x0="334.35" y0="60.15" x1="338.1" y1="63" x2="341.6" y2="66.5" line="0" />
				<edge id="1" x0="341.6" y0="66.5" x1="345.1" y1="70" x2="348" y2="73.8" line="0" />
				<edge id="2" x0="360" y0="111.3" x1="360.25" y1="137.45" x2="341.65" y2="156.05" line="0" />
				<edge id="3" x0="348" y0="73.8" x1="360.15" y1="89.95" x2="360" y2="111.3" line="0" />
				<edge id="4" x0="252.05" y0="66.45" x1="270.6" y1="47.9" x2="296.7" y2="48" line="0" />
				<edge id="5" x0="229" y0="157.7" x1="218.65" y1="157.75" x2="211.25" y2="165.15" line="0" />
				<edge id="6" x0="211.25" y0="165.15" x1="203.95" y1="172.45" x2="203.85" y2="182.85" line="0" />
				<edge id="7" x0="254.05" y0="182.85" x1="254.05" y1="172.45" x2="246.75" y2="165.15" line="0" />
				<edge id="8" x0="246.75" y0="165.15" x1="239.45" y1="157.75" x2="229" y2="157.7" line="0" />
				<edge id="9" x0="58.75" y0="285.95" x1="58.75" y1="259.75" x2="77.35" y2="241.15" line="0" />
				<edge id="10" x0="77.4" y0="330.7" x1="58.85" y1="312.15" x2="58.75" y2="285.95" line="0" />
				<edge id="11" x0="122.05" y0="349.25" x1="95.95" y1="349.25" x2="77.4" y2="330.7" line="0" />
				<edge id="12" x0="273.75" y0="223.95" x1="266" y1="231.7" x2="259.8" y2="227.5" line="0" />
				<edge id="13" x0="259.8" y0="227.5" x1="254.1" y1="223.6" x2="254.1" y2="213.7" line="0" />
				<edge id="14" x0="197.45" y0="300.25" x1="182.2" y1="315.5" x2="166.95" y2="330.75" line="1" />
				<edge id="15" x0="203.95" y0="285.05" x1="203.8" y1="293.9" x2="197.45" y2="300.25" line="0" />
				<edge id="16" x0="254.1" y0="213.7" x1="254.15" y1="196.75" x2="254.05" y2="182.85" line="0" />
				<edge id="17" x0="166.95" y0="330.75" x1="148.35" y1="349.35" x2="122.05" y2="349.25" line="0" />
				<edge id="18" x0="203.85" y0="182.85" x1="204.65" y1="237.85" x2="203.95" y2="285.05" line="0" />
				<edge id="19" x0="77.35" y0="241.15" x1="164.7" y1="153.8" x2="252.05" y2="66.45" line="1" />
				<edge id="20" x0="296.7" y0="48" x1="318.05" y1="47.85" x2="334.35" y2="60.15" line="0" />
				<edge id="21" x0="341.65" y0="156.05" x1="307.7" y1="190" x2="273.75" y2="223.95" line="1" />
				</shape>
			
			
			shape_data = new ShapeData(dat);
			
			line.graphics.clear();
			line.graphics.lineStyle( 0 , 0x999999 );
			shape_data.draw( line.graphics );
			
			
			//obj
			obj.graphics.beginFill( 0xFFFFFF );
			obj.graphics.drawRect( -8 , -3 , 16 , 6 );
			obj.graphics.endFill();
			
			//
			step = 0.0;
			line_step = 0;
			vk = 0.0;
			addEventListener( Event.ENTER_FRAME , idle );
			
			stage.addEventListener( MouseEvent.MOUSE_DOWN , function(e:MouseEvent):void{ accel=true; } );
			stage.addEventListener( MouseEvent.MOUSE_UP   , function(e:MouseEvent):void{ accel=false; } );
		}
		
		private function idle( evt:Event ):void{
			if( accel ){
				vk += ( vk<0.05 ) ? 0.0002 : 0;
			}else{
				vk -= ( vk>=0.0002 ) ? 0.0002 : 0;
			}
			
			var ed:IEdge = shape_data.getEdgeAt(line_step);
			
			var vp:VectorPoint = ed.getVectorPointAt( step );
			var rate:Number    = shape_data.rates[line_step];
			
			obj.x = vp.x;
			obj.y = vp.y;
			obj.rotation = Math.atan2( vp.vector.y , vp.vector.x ) / Math.PI * 180;
			
			
			step+=vk / rate;
			if( step>=1.0 ){
				step -= 1.0;
				step *= rate;
				line_step++;
				if( line_step>=shape_data.length ){
					line_step = 0;
					step /= shape_data.rates[line_step];
				}
			}
		}
		
	}
	
}
